/* lib/VolumeViz/C/basic.h.  Generated by configure.  */
#ifndef SIMVOLEON_BASIC_H
#define SIMVOLEON_BASIC_H

/**************************************************************************\
 *
 *  This file is part of the SIM Voleon visualization library.
 *  Copyright (C) 2003-2004 by Systems in Motion.  All rights reserved.
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  ("GPL") version 2 as published by the Free Software Foundation.
 *  See the file LICENSE.GPL at the root directory of this source
 *  distribution for additional information about the GNU GPL.
 *
 *  For using SIM Voleon with software that can not be combined with
 *  the GNU GPL, and for taking advantage of the additional benefits
 *  of our support services, please contact Systems in Motion about
 *  acquiring a SIM Voleon Professional Edition License.
 *
 *  See <URL:http://www.coin3d.org/> for more information.
 *
 *  Systems in Motion, Postboks 1283, Pirsenteret, 7462 Trondheim, NORWAY.
 *  <URL:http://www.sim.no/>.
 *
\**************************************************************************/

/*
  NOTE: basic.h is automatically generated from basic.h.in, so don't
  edit basic.h directly.
*/

/* *********************************************************************** */

/* A unique identifier to recognize the Systems in Motion's SimVoleon
 * library from application code.
 */
#define __SIMVOLEON__

/* The following #undef'ed defines are automatically defined and
 * synchronized with the settings in configure.in when ``configure''
 * is executed.
 *
 * The #ifndef wrapper is necessary because during development, these
 * are also defined in the config.h file generated by ``configure''.
 */
#ifndef SIMVOLEON_VERSION

/* These are available for adding or omitting features based on
 * SimVoleon version numbers in client application sources.
 */
#define SIMVOLEON_MAJOR_VERSION 2
#define SIMVOLEON_MINOR_VERSION 0
#define SIMVOLEON_MICRO_VERSION 1
#define SIMVOLEON_VERSION "2.0.1"

#endif /* !SIMVOLEON_VERSION */ /* Ends configure-generated defines. */

/* *********************************************************************** */

/* Precaution to avoid an some errors easily made by the application
   programmer. */
#ifdef SIMVOLEON_DLL_API
# error Leave the internal SIMVOLEON_DLL_API define alone.
#endif /* SIMVOLEON_DLL_API */
#ifdef SIMVOLEON_INTERNAL
# ifdef SIMVOLEON_NOT_DLL
#  error The SIMVOLEON_NOT_DLL define is not supposed to be used when building the library, only when building Win32 applications.
# endif /* SIMVOLEON_INTERNAL && SIMVOLEON_NOT_DLL */
# ifdef SIMVOLEON_DLL
#  error The SIMVOLEON_DLL define is not supposed to be used when building the library, only when building Win32 applications.
# endif /* SIMVOLEON_INTERNAL && SIMVOLEON_DLL */
#endif /* SIMVOLEON_INTERNAL */

/*
  On MSWindows platforms, one of these defines must always be set when
  building application programs:

   - "SIMVOLEON_DLL", when the application programmer is using the library
     in the form of a dynamic link library (DLL)

   - "SIMVOLEON_NOT_DLL", when the application programmer is using the
     library in the form of a static object library (LIB)

  Note that either SIMVOLEON_DLL or SIMVOLEON_NOT_DLL _must_ be
  defined by the application programmer on MSWindows platforms, or
  else the #error statement will hit. Set up one or the other of these
  two defines in your compiler environment according to how the
  library was built -- as a DLL (use "SIMVOLEON_DLL") or as a LIB (use
  "SIMVOLEON_NOT_DLL").

  (Setting up defines for the compiler is typically done by either
  adding something like "/DSIMVOLEON_DLL" to the compiler's argument
  line (for command-line build processes), or by adding the define to
  the list of preprocessor symbols in your IDE GUI (in the MSVC IDE,
  this is done from the "Project"->"Settings" menu, choose the "C/C++"
  tab, then "Preprocessor" from the dropdown box and add the
  appropriate define)).

  It is extremely important that the application programmer uses the
  correct define, as using "SIMVOLEON_NOT_DLL" when "SIMVOLEON_DLL" is
  correct will cause mysterious crashes.
 */
/* FIXME: use a feature check to see if this is a platform which can
   recognize the __declspec keyword instead of the crap #if below.
   20030324 mortene. */
#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__) || defined(__NT__)
# ifdef SIMVOLEON_INTERNAL
#  ifdef SIMVOLEON_MAKE_DLL
#   define SIMVOLEON_DLL_API __declspec(dllexport)
#  endif /* SIMVOLEON_MAKE_DLL */
# else /* !SIMVOLEON_INTERNAL */
#  ifdef SIMVOLEON_DLL
#   define SIMVOLEON_DLL_API __declspec(dllimport)
#  else /* !SIMVOLEON_DLL */
#   ifndef SIMVOLEON_NOT_DLL
#    error Define either SIMVOLEON_DLL or SIMVOLEON_NOT_DLL as appropriate for your linkage! See Inventor/C/basic.h for further instructions.
#   endif /* SIMVOLEON_NOT_DLL */
#  endif /* !SIMVOLEON_DLL */
# endif /* !SIMVOLEON_INTERNAL */
#endif /* Microsoft Windows */

/* Empty define to avoid errors when _not_ compiling an MSWindows DLL. */
#ifndef SIMVOLEON_DLL_API
# define SIMVOLEON_DLL_API
#endif /* !SIMVOLEON_DLL_API */


#endif /* !SIMVOLEON_BASIC_H */
